unit RLEBmp;
{
  RLE Picture format.

  Copyright (c) 1997 Demidov Andre (andre@lion.tu-chel.ac.ru)

  Do register before using:
     TPicture.RegisterFileFormat('RLE','Windows bitmap files',TRLEBitmap);
}
interface

uses WinTypes, WinProcs, SysUtils, Classes, Graphics;

{ Graphics Objects }
type TRLEBitmap=class(TBitmap)
  procedure LoadFromStream(Stream: TStream); override;
end;

implementation

procedure TRLEBitmap.LoadFromStream(Stream: TStream);
var
  Size: longInt;
  Bmf: TBitmapFileHeader;
  BC: TBitmapCoreHeader;
  BI: TBitmapInfoHeader;
  DImage: TMemoryStream;
  SImage:TFileStream;
  Image: TStream;
  IWidth, IHeight: Integer;
  BWidth, nl, RLETip, clrSize, nsbf: Integer;
  IMonochrome: Boolean;
  Buf: PChar;
  sbf:array [0..1023] of char;
procedure readByte(var K:byte);
begin
  if nsbf>=1024 then
  begin
    Image.Read(sbf,1024);
    nsbf:=0;
  end;
  K:=byte(sbf[nsbf]);
  nsbf:=nsbf+1;
end;
procedure decompressLine8(a:PChar);
var i,j:integer;
    k,bt:Byte;
begin
 i:=0;
 while i<=iWidth do
 begin
   ReadByte(k);
   if k=0 then
   begin
     ReadByte(k);
     case k of
       0,1:
         Break;
       2: begin
            ReadByte(k);
            ReadByte(bt);
          end;
       else
         begin
           for j:=1 to k do
           begin
             ReadByte(bt);
             a[i]:=char(bt);
             i:=i+1;
           end;
           if (k and 1)<>0 then
             ReadByte(bt);
         end
     end
   end
   else
   begin
     ReadByte(bt);
     if k=1 then
     begin
       a[i]:=char(bt);
       i:=i+1;
     end
     else
     begin
       FillChar(a[i],k,bt);
       i:=i+k;
     end;
   end
 end
end;

procedure decompressLine4(a:PChar);
var i,j:integer;
    k,bt:Byte;

procedure sethalfbyte(b:PChar;n:integer; t:byte);
var n2:integer;
begin
  n2:=n div 2;
  t:=t and 15;
  if (n and 1)=0 then
    b[n2]:=char(integer(t)*16)
  else
    b[n2]:=char(byte(b[n2]) or t);
end;

begin
 i:=0;
 while i<=iWidth do
 begin
   ReadByte(k);
   if k=0 then
   begin
     ReadByte(k);
     case k of
       0,1:
          Break;
       2: begin
            ReadByte(k);
            ReadByte(bt);
          end;
       else
         begin
           for j:=1 to (k div 2) do
           begin
             ReadByte(bt);
             sethalfbyte(a,i,bt div 16);
             sethalfbyte(a,i+1,bt);
             i:=i+2;
           end;
           if (k and 1)<>0 then
           begin
             ReadByte(bt);
             sethalfbyte(a,i,bt div 16);
             i:=i+1;
           end;
           if (((k+1) div 2) and 1)<>0 then
             ReadByte(bt);
         end
     end
   end
   else
   begin
     ReadByte(bt);
     while k>=2 do
     begin
       sethalfbyte(a,i,bt div 16);
       sethalfbyte(a,i+1,bt);
       i:=i+2;
       k:=k-2;
     end;
     if k=1 then
     begin
       sethalfbyte(a,i,bt div 16);
       i:=i+1;
     end;
   end
 end
end;

procedure InvalidBitmap;
begin
  raise EInvalidGraphic.Create('Invalid Bitmap');
end;

begin
  size:=Stream.Size-Stream.Position;
  if Size = 0 then
    inherited LoadFromStream(Stream)
  else
  begin
    Image := Stream;
    Image.Read(Bmf, SizeOf(Bmf));
    if Bmf.bfType <> $4D42 then InvalidBitmap;
      Image.Read(Size, SizeOf(Size));
      Image.Seek(-SizeOf(Size), 1);
      if Size = SizeOf(BC) then
      begin
        Image.Seek(-SizeOf(bmf), 1);
        inherited LoadFromStream(Stream);
      end
      else if Size = SizeOf(BI) then
      begin
        Image.Read(BI, SizeOf(BI));
        IHeight := BI.biHeight;
        IWidth := BI.biWidth;
        IMonochrome := (BI.biPlanes = 1) and (BI.biBitCount = 1);
        RLETip:=BI.biCompression;
        if (RLETip=bi_RLE8) or (RLETip=bi_RLE4) then
        begin
          bWidth:=integer(word(BI.biWidth div (8 div BI.biBitCount)) and $FFFC);
          if bWidth*(8 div BI.biBitCount)<BI.biWidth then
            bWidth:=bWidth+4;
          DImage:=TMemoryStream.Create;
          clrSize:=(integer(1) shl BI.biBitCount)*4;
          bmf.bfSize:=SizeOf(Bmf)+SizeOf(BI)+ClrSize+
                    longint(bWidth)*iHeight;
          DImage.SetSize(bmf.bfSize);
          DImage.Position := 0;
          DImage.Write(Bmf,Sizeof(Bmf));
          BI.biCompression:=0;
          BI.biSizeImage:=longint(bWidth)*iHeight;
          DImage.Write(BI,Sizeof(BI));
          Buf:=strAlloc(ClrSize);
          Image.Read(Buf^, ClrSize);
          DImage.Write(Buf^, ClrSize);
          strDispose(buf);
          Buf:=StrAlloc(bWidth*2);
          nsbf:=1024;
          For nl:=1 to IHeight do
          begin
            FillChar(Buf^,bWidth,char(0));
            if RLETip=bi_RLE8 then
              DecompressLine8(Buf)
            else
              DecompressLine4(Buf);
            DImage.Write(Buf^,bWidth);
          end;
          StrDispose(Buf);
          DImage.Position:=0;
          inherited LoadFromStream(DImage);
          {SImage:=TFileStream.Create('TEST.BMP',fmCreate);
          SImage.Write(DImage.Memory^,DImage.size);
          SImaGE.Destroy;}
          DImage.Free;
        end
        else
        begin
          Image.Seek(-SizeOf(bmf)-sizeof(BI), 1);
          inherited LoadFromStream(Stream);
        end
      end
      else InvalidBitmap;
  end;
end;

end.
